From 4f74da44a6ca18c76fe74ac85fc7f3104421775f Mon Sep 17 00:00:00 2001
From: Vivek Anand <vivekanand1101@gmail.com>
Date: Apr 10 2016 10:54:24 +0000
Subject: [PATCH 4/24] Basics of pygit2 approach for github issues completed


---

diff --git a/pagure_importer/__init__.py b/pagure_importer/__init__.py
index de741ae..fbab797 100644
--- a/pagure_importer/__init__.py
+++ b/pagure_importer/__init__.py
@@ -1 +1,2 @@
-from sources import *
+import lib
+import settings
diff --git a/pagure_importer/forms.py b/pagure_importer/forms.py
index 1aa883a..ddc24f0 100644
--- a/pagure_importer/forms.py
+++ b/pagure_importer/forms.py
@@ -1,35 +1,10 @@
-from sources.importer_github import GithubImporter
 import getpass
 
+from lib.sources.importer_github_new import GithubImporter
+from settings import REPO_PATH, REPO_NAME
+
 def form_github_issues():
     github_username = raw_input('Enter you Github Username: ')
     github_password = getpass.getpass('Enter your github password: ')
-    github_project_name = raw_input('Enter github project name: ')
-    pagure_api_key = raw_input('Enter your pagure api key: ')
-    pagure_project_name = raw_input('Enter pagure project name: ')
-
-    is_forked = raw_input('Is the pagure project a forked repo ? (y/n): ') or 'n'
-    if is_forked.lower() == 'y':
-        pagure_username = raw_input('Enter your pagure username: ')
-    else:
-        pagure_username = None
-
-    is_pagure_io = raw_input(
-                'Is the pagure instance url - https://pagure.io ?: (y/n) ') or 'y'
-    if is_pagure_io.lower() == 'n':
-        pagure_instance = raw_input('Enter the pagure instance url: ') or 'https://pagure.io'
-    else:
-        pagure_instance = 'https://pagure.io'
-
-    status = raw_input(
-            'Enter status of the issues to be imported (all/open/closed): ') or 'all'
-
-    github_importer = GithubImporter(
-                        github_username=github_username,
-                        github_password=github_password,
-                        github_project_name=github_project_name,
-                        pagure_api_key=pagure_api_key,
-                        pagure_project_name=pagure_project_name,
-                        pagure_username=pagure_username,
-                        instance_url=pagure_instance)
-    github_importer.import_issues(status)
+    github_project_name = raw_input('Enter github project name like: "pypingou/pagure" without quotes: ')
+    return (github_username, github_password, github_project_name)
diff --git a/pagure_importer/lib/__init__.py b/pagure_importer/lib/__init__.py
new file mode 100644
index 0000000..c1724e7
--- /dev/null
+++ b/pagure_importer/lib/__init__.py
@@ -0,0 +1,153 @@
+import git
+import models
+
+import os
+import getpass
+import requests
+import json
+from github import Github
+from requests.auth import HTTPBasicAuth
+import pagure_importer
+import pagure_importer.lib
+from pagure_importer.lib.exceptions import FileNotFound, EmailNotFound
+
+def generate_json_for_github_contributors(github_username, github_password, \
+                                                github_project_name):
+    ''' Creates a file containing a list of dicts containing the username and emails
+    of the contributors in the given github project
+    '''
+
+    github_obj = Github(github_username, github_password)
+    project = github_obj.get_repo(github_project_name)
+    commits_url = project.commits_url.replace('{/sha}', '')
+
+    page = 0
+    contributors = []
+    while True:
+        page += 1
+        payload = {'page': page }
+        data_ = json.loads(requests.get(commits_url, params=payload, auth=HTTPBasicAuth(github_username, github_password)).text)
+
+        if not data_:
+            break
+
+        for data in data_:
+            try:
+                contributor = data['commit']['committer']
+                contributor_email = contributor['email']
+                contributor_fullname = contributor['name']
+                contributor_name = data['committer']['login']
+            except TypeError:
+                print 'Maybe one of the contributors is dropped because of lack of details'
+                continue
+
+            json_data = {
+                'name': contributor_name,
+                'fullname': contributor_fullname,
+                'emails': [contributor_email]
+            }
+
+            present = False
+            for i in contributors:
+                if i == json_data:
+                    present = True
+                    break
+
+            if not present:
+                print 'contributor added: ', len(contributors) + 1
+                contributors.append(json_data)
+
+    with open('contributors.json', 'w') as f:
+        f.write(json.dumps(contributors))
+
+    return
+
+
+def generate_json_for_github_issue_commentors(github_username, github_password, \
+                                                github_project_name):
+    ''' Will create a json file containing details of all the user
+    who have commented on any issue in the given project
+    '''
+
+    github_obj = Github(github_username, github_password)
+    project = github_obj.get_repo(github_project_name)
+    issue_comment_url = project.issue_comment_url.replace('{/number}', '')
+
+    page = 0
+    issue_commentors = []
+    while True:
+        page += 1
+        payload = {'page': page }
+        data_ = json.loads(requests.get(issue_comment_url, params=payload, auth=HTTPBasicAuth(github_username, github_password)).text)
+
+        if not data_:
+            break
+
+        for data in data_:
+            try:
+                commentor = data['user']['login']
+            except TypeError:
+                print 'Maybe one of the issue commentors have been dropped because of lack of details'
+                continue
+
+            present = False
+            for i in issue_commentors:
+                if i == commentor:
+                    present = True
+                    break
+
+            if not present:
+                print 'commentor added: ', len(issue_commentors) + 1
+                issue_commentors.append(commentor)
+
+    with open('issue_commentors.json', 'w') as f:
+        f.write(json.dumps(issue_commentors))
+    return
+
+
+def assemble_github_contributors_commentors():
+    ''' It uses the files: issue_commentors.json and contributors.json
+    Assembles and creates a file: assembled_commentors.json
+    To use: just fill the None and [] in the final file '''
+
+    with open('issue_commentors.json', 'r') as ic:
+        issue_names = json.load(ic)
+
+    with open('contributors.json', 'r') as c:
+        contributors = json.load(c)
+
+    names = []
+    for i in issue_names:
+        found = False
+        for j in contributors:
+            if j.get('name', None) == i:
+                names.append(j)
+                found = True
+
+        if not found:
+            d = {'name': i, 'fullname': None, 'emails': []}
+            names.append(d)
+
+    with open('assembled_commentors.json', 'w') as ac:
+        json.dump(names, ac)
+
+
+def github_get_commentor_email(name):
+    ''' Will return the issue commentor email as given in the
+    assembled_commentors.json file
+    '''
+
+    if not os.path.exists('assembled_commentors.json'):
+        raise FileNotFound('The assembled_commentors.json file must be present \
+                Rerun the program and choose to generate the json files')
+
+    with open('assembled_commentors.json') as ac:
+        data = json.load(ac)
+
+    for i in data:
+        if i.get('name', None) == name:
+            if i['emails']:
+                return i['emails']
+            else:
+                raise EmailNotFound('You need to fill out all the emails of the \
+                        issue commentors')
diff --git a/pagure_importer/lib/exceptions.py b/pagure_importer/lib/exceptions.py
new file mode 100644
index 0000000..a5ab5fe
--- /dev/null
+++ b/pagure_importer/lib/exceptions.py
@@ -0,0 +1,22 @@
+class GithubBadCredentials(Exception):
+    ''' Raised when username/password for github is wrong '''
+    def __init__(self, msg):
+        self.msg = msg
+
+
+class GithubRepoNotFound(Exception):
+    ''' Raised when the repo is not found for the user '''
+    def __init__(self, msg):
+        self.msg = msg
+
+
+class FileNotFound(Exception):
+    ''' Raised when a certain file is not found '''
+    def __init__(self, msg):
+        self.msg = msg
+
+
+class EmailNotFound(Exception):
+    ''' Raised when email is not found '''
+    def __init__(self, msg):
+        self.msg = msg
diff --git a/pagure_importer/lib/git.py b/pagure_importer/lib/git.py
index eff314f..33eba48 100644
--- a/pagure_importer/lib/git.py
+++ b/pagure_importer/lib/git.py
@@ -10,18 +10,18 @@ import json
 
 from repo import *
 
-def update_git(obj, repo_path, repofolder):
+def update_git(obj, repo_path, repo_folder):
     """ Update the given issue in its git.
     This method forks the provided repo, add/edit the issue whose file name
     is defined by the uid field of the issue and if there are additions/
     changes commit them and push them back to the original repo.
     """
 
-    if not repofolder:
+    if not repo_folder:
         return
 
     # Get the fork
-    repopath = os.path.join(repofolder, repo_path)
+    repopath = os.path.join(repo_folder, repo_path)
 
     # Clone the repo into a temp folder
     newpath = tempfile.mkdtemp(prefix='pagure-')
diff --git a/pagure_importer/lib/sources/importer_github.py b/pagure_importer/lib/sources/importer_github.py
new file mode 100644
index 0000000..2e635b6
--- /dev/null
+++ b/pagure_importer/lib/sources/importer_github.py
@@ -0,0 +1,133 @@
+from github import Github
+import pagure_importer
+import pagure_importer.lib
+from pagure_importer.lib import models
+from pagure_importer.lib import github_get_commentor_email
+from pagure_importer.lib.exceptions import GithubBadCredentials, GithubRepoNotFound
+
+class GithubImporter():
+    ''' Imports from Github using PyGithub and libpagure '''
+    def __init__(
+            self,
+            github_username,
+            github_password,
+            github_project_name):
+        self.github_username = github_username
+        self.github_password = github_password
+        self.github_project_name = github_project_name
+        self.github = Github(github_username, github_password)
+
+    def import_issues(self, repo_path, repo_folder, status='all'):
+        ''' Imports the issues on github for
+        the given project
+        '''
+        github_user = None
+        try:
+            github_user = self.github.get_user(self.github_username)
+        except:
+            raise GithubBadCredentials(
+                    'Given github credentials are not correct')
+        repo = self.github.get_repo(self.github_project_name)
+        try:
+            repo_name = repo.name
+        except:
+            raise GithubRepoNotFound(
+                    'Repo not found, project name wrong')
+
+        for github_issue in repo.get_issues(state=status):
+
+            #title of the issue
+            pagure_issue_title = github_issue.title
+
+            #body of the issue
+            if github_issue.body:
+                pagure_issue_content = github_issue.body
+            else:
+                pagure_issue_content = '#No Description Provided'
+
+            #Some details of a issue
+            if github_issue.state != 'closed':
+                pagure_issue_status = 'Open'
+            else:
+                pagure_issue_status = 'Fixed'
+
+            pagure_issue_created_at = github_issue.created_at
+
+            #Not sure how to deal with this atm
+            pagure_issue_assignee = None
+
+            if github_issue.labels:
+                pagure_issue_tags = [i.name for i in github_issue.labels]
+            else:
+                pagure_issue_tags = []
+
+
+            #few things not supported by github
+            pagure_issue_depends = []
+            pagure_issue_blocks = []
+            pagure_issue_is_private = False
+
+
+            #User who created the issue
+            pagure_issue_user = models.User(
+                    name=github_issue.user.login,
+                    fullname=github_issue.user.name,
+                    emails=[github_issue.user.email])
+
+
+            pagure_issue = models.Issue(
+                    id=None,
+                    title = pagure_issue_title,
+                    content = pagure_issue_content,
+                    status = pagure_issue_status,
+                    date_created = pagure_issue_created_at,
+                    user = pagure_issue_user.to_json(),
+                    private = pagure_issue_is_private,
+                    tags = pagure_issue_tags,
+                    depends = pagure_issue_depends,
+                    blocks = pagure_issue_blocks,
+                    assignee = pagure_issue_assignee)
+
+
+            #comments on the issue
+            comments = []
+            for comment in github_issue.get_comments():
+
+                comment_user = comment.user
+                pagure_issue_comment_user_email = comment_user.email
+                pagure_issue_comment_body = comment.body
+                pagure_issue_comment_created_at = comment.created_at
+                pagure_issue_comment_updated_at = comment.updated_at
+
+
+                #No idea what to do with this right now
+                #editor: not supported by github api
+                pagure_issue_comment_parent = None
+                pagure_issue_comment_editor = None
+
+                #comment updated at
+                pagure_issue_comment_edited_on = comment.updated_at
+
+                #The User who commented
+                pagure_issue_comment_user = models.User(
+                        name=comment_user.login,
+                        fullname=comment_user.name,
+                        emails=[comment_user.email] if comment_user.email else github_get_commentor_email(comment_user.login))
+
+                #Object to represent comment on an issue
+                pagure_issue_comment = models.IssueComment(
+                        id=None,
+                        comment=pagure_issue_comment_body,
+                        parent=pagure_issue_comment_parent,
+                        date_created=pagure_issue_comment_created_at,
+                        user=pagure_issue_comment_user.to_json(),
+                        edited_on=pagure_issue_comment_edited_on,
+                        editor=pagure_issue_comment_editor)
+
+                comments.append(pagure_issue_comment.to_json())
+
+            #add all the comments to the issue object
+            pagure_issue.comments = comments
+
+            #update the local git repo
+            pagure_importer.lib.git.update_git(pagure_issue, repo_path, repo_folder)
diff --git a/pagure_importer/run.py b/pagure_importer/run.py
index a485493..2753298 100644
--- a/pagure_importer/run.py
+++ b/pagure_importer/run.py
@@ -1,11 +1,35 @@
 #!/usr/bin/env python
-
+import getpass
 from forms import form_github_issues
-from settings import IMPORT_SOURCES, IMPORT_OPTIONS
+from settings import IMPORT_SOURCES, IMPORT_OPTIONS, REPO_NAME, REPO_PATH
+import pagure_importer
+import pagure_importer.lib
+import pagure_importer.lib.sources
+from pagure_importer.lib.sources.importer_github import GithubImporter
+from pagure_importer.lib import generate_json_for_github_contributors, \
+            generate_json_for_github_issue_commentors, \
+            assemble_github_contributors_commentors
 
 def github_handler(item):
     if item.lower() == 'issues':
-        form_github_issues()
+        github_username, github_password, github_project_name = form_github_issues()
+        gen_json = raw_input('Do you want to generate jsons for project\'s contributers and issue commentors? (y/n): ')
+        if gen_json == 'n':
+            github_importer = GithubImporter(
+                            github_username=github_username,
+                            github_password=github_password,
+                            github_project_name=github_project_name)
+            github_importer.import_issues(repo_path=REPO_NAME, repo_folder=REPO_PATH)
+        else:
+            generate_json_for_github_contributors(
+                                            github_username,
+                                            github_password,
+                                            github_project_name)
+            generate_json_for_github_issue_commentors(
+                                            github_username,
+                                            github_password,
+                                            github_project_name)
+            assemble_github_contributors_commentors()
     return
 
 def main():
@@ -21,7 +45,6 @@ def main():
 
     if source.lower() == 'github':
         github_handler(item)
-
     return
 
 if __name__ == '__main__':
diff --git a/pagure_importer/settings.py b/pagure_importer/settings.py
index 13f8332..9761aed 100644
--- a/pagure_importer/settings.py
+++ b/pagure_importer/settings.py
@@ -1,2 +1,7 @@
+import os
+
 IMPORT_SOURCES = ['github']
 IMPORT_OPTIONS = {'github': ['issues']}
+
+REPO_NAME = os.environ.get('REPO_NAME', None) #this has to be a bare repo
+REPO_PATH = os.environ.get('REPO_PATH', None) #the parent of the git directory
